
# The middle and maximum «shadowBlur» values to show / animate to
midValue = 5
maxValue = 10

# The animation duration
Framer.Defaults.Animation.time = 0.5


# Adjust the Text Layer’s height automatically
theTextLayer.autoHeight = yes


# Functions for the slider

# round number to a set amount
round = (number, nearest) ->
	Math.round(number / nearest) * nearest

# get the amount of decimals of a number
retr_dec = (num) ->
	return ("#{num}".split('.')[1] || []).length

# Setup title
title.template =
	v: ""
	d: "«default»"

# Slider
slider = new SliderComponent
	height: 5
	width: Screen.width - 50
	knobSize: 25
	backgroundColor: "rgba(255,255,255,0.5)"
	x: 25
	maxY: Screen.height - buttonA.height - 55
	min: 0
	max: maxValue
slider.fill.backgroundColor = "#fff"

slider.value = 0

slider.onValueChange ->
	theTextLayer.shadowBlur = @value

# Setup buttons

for button in [buttonA, buttonB, buttonC]
	# Resize horizontally
	button.width = ( Screen.width - 100 ) / 3
	# Change color on tap and release
	button.onTouchStart ->
		@backgroundColor = "#fff"
		@children[0].color = artboard.backgroundColor
	button.onTouchEnd ->
		@backgroundColor = artboard.backgroundColor
		@children[0].color = "#fff"

# Setup animations

# animate to default value
buttonA.children[0].text = 0
buttonA.onTap ->
	slider.animate
		value: 0

# # animate to middle value
buttonB.children[0].text = midValue
buttonB.onTap ->
	slider.animate
		value: midValue

# animate to maximum value
buttonC.children[0].text = maxValue
buttonC.onTap ->
	slider.animate
		value: maxValue

# listen to layer changes
roundBy = 0.5
theTextLayer.on "change:shadowBlur", ->
	valueToShow = Utils.round (round @shadowBlur, roundBy), (retr_dec roundBy)
	if valueToShow is 0
		title.template =
			v: ""
			d: "«default»"
	else
		title.template =
			v: valueToShow
			d: ""
